library mymodule;
// Demo-Library fr IPS-Module
// Thomas Dreler 2009
// frei fr private Nutzung

uses
  FastMM4,
  Windows,
  StrUtils,
  Classes,
  SysUtils,
  UIPSTypes,        //SDK
  UIPSModuleTypes,  //SDK
  UModuleinterface in 'UModuleInterface.pas',  //interface Definitionen
  UDevice in 'UDevice.pas';

{$R *.res}

//Standard-Texte, mussen bei jeder Library existieren
//------------------------------------------------------------------------------
procedure IPSModuleRegister(Kernel: IIPSKernel; ModuleRegistry: IIPSModuleRegistry); stdcall; forward;
procedure IPSModuleUnregister(); stdcall; forward;

//------------------------------------------------------------------------------
const LibInfo: TIPSLibraryInfo = (
                                 mUniqueID    : '{30dec678-a21a-41f8-840b-cfd52a4a9436}'; //Fr jedes Modul mit STRG-SHIFT-G neu erstellen !!
                                 //-------------------------- //nchste 3 Zeilen anpassen, Build muss leider Manuell hizugefgt werden
                                 mAuthor      : 'Dein Name';
                                 mURL         : 'Deine.URL';
                                 mName        : 'My Library';
                                 mVersion     : {CompileVersion}$0204{/CompileVersion}; { Hi - MajorV, Lo - MinorV }
                                 mBuild       : {CompileBuild}9{/CompileBuild};
                                 mDate        : {CompileTime}0{/CompileTime};
                                 //-------------------------- //nicht ndern!
                                 mKernelVersion : KERNEL_VERSION;
                                 //--------------------------
                                 fRegister    : IPSModuleRegister;
                                 fUnregister  : IPSModuleUnregister;
                               );

//------------------------------------------------------------------------------
var vKernel: IIPSKernel;

//------------------------------------------------------------------------------
procedure IPSLibraryInfo(var LibraryInfo: PIPSLibraryInfo); stdcall;
begin

 LibraryInfo := @LibInfo;

end;

//------------------------------------------------------------------------------
procedure IPSModuleRegister(Kernel: IIPSKernel; ModuleRegistry: IIPSModuleRegistry); stdcall;
{Modul registerfunktion
fr jedes Modul(Device, Splitter muss ein Eintag existieren. Die Interface und Typinfo
sollten ber units bekannt gemacht sein
}

begin

 vKernel := Kernel;
 vKernel.LogMessage(KL_MESSAGE, 0, LibInfo.mName, 'Register Build '+inttostr(LibInfo.mBuild));

 //Register Classes
 {ein Eintrag pro Modul. Es knnen auch mehrere Module in einer Library registriert werden
 alle Module landen dann in der gleichen DLL. Type und Interface mssen anschliessend
 im Modul definiert werden: Type=ObjektType in UDevice, Interface in ModulInterface
 Eine gute Praxis ist es, fr jedes Device/Splitter eine eigene Unit anzulegen,
 so das innerhalb einer Unit nur mit einem Objekt gearbeitet werden muss
 Die PHP-Funktionen werden den als NamensPrefix den letzter Parameter haben}
 ModuleRegistry.RegisterModule(TIPSDevice, TypeInfo(IIPSDevice), 'MyDevice');

end;

//------------------------------------------------------------------------------
procedure IPSModuleUnregister(); stdcall;
begin

 vKernel.LogMessage(KL_MESSAGE, 0, LibInfo.mName, 'Unregister');
 vKernel := NIL;

end;

//==============================================================================
exports IPSLibraryInfo;

begin
 //
end.

